
(LISTING 1)
   type
      Point = object
         x, y, Color : integer;
         procedure Create( PtX, PtY, C : integer );
         procedure Move( PtX, PtY : integer );
         procedure SetColor( c : integer );
         procedure Erase;
         function  GetColor : integer;
         function  GetX : integer;
         function  GetY : integer;
      end;

(LISTING 2)
   var
      ButtonType = ( Rounded, Square, ThreeD );
      Button = object( Point )
         Exist, State, Rotate : boolean;
         FontSize, TypeFace, SizeX, SizeY : integer;
         ThisButton : ButtonType;
         BtnTxt : STR40;
         procedure Create( PtX, PtY, Width, Height, C : integer;
                           Text : STR40 );
         procedure Draw;
         procedure Erase;
         procedure Initialize;
         procedure Invert;
         procedure Move( PtX, PtY : integer );
         procedure SetButtonType( WhatType : ButtonType );
         procedure SetColor( C : integer );
         procedure SetLabel( Text : STR40 );
         procedure SetState( BState : boolean );
         procedure SetTypeFace( TxtFont : integer );
         procedure SetTypeSize( TxtSize : integer );
         function  ButtonHit( MouseX, MouseY: integer ): boolean;
         function  GetHeight : integer;
         function  GetState : boolean;
         function  GetTextSize : integer;
         function  GetType : ButtonType;
         function  GetWidth : integer;
      end;

(LISTING 3)
procedure Button.Create( PtX, PtY, Width, Height, C : integer;
                         Text : STR40 );
   begin
      SetViewPort( 0, 0, GetMaxX, GetMaxY, ClipOn );
      SetTextJustify( CenterText, CenterText );
      x := PtX;
      y := PtY;
      SizeX := Width;
      SizeY := Height;
      if SizeX < 20 then SizeX := 20;
      if SizeY < 20 then SizeY := 20;
      if( SizeY > SizeX ) then Rotate := TRUE
                          else Rotate := FALSE;
      Color  := C;
      State  := FALSE;
      Exist  := TRUE;
      BtnTxt := Text;
      Draw;
   end;
procedure Button.Move( PtX, PtY : integer );
   begin
      Destroy;
      x := PtX;
      y := PtY;
      Draw;
   end;
procedure Button.SetLabel( Text : STR40 );
   begin
      BtnTxt := Text;
      Draw;
   end;
procedure Button.SetColor( C : integer );
   begin
      Color := C;
      Draw;
   end;
procedure Button.Invert;
   begin
      State := not State;
      Draw;
   end;
procedure Button.SetState( BState : boolean );
   begin
      if( State <> BState ) then Invert;
   end;

(LISTING 4)
function Button.ButtonHit( MouseX, MouseY: integer ): boolean;
   var
      Result : boolean;
   begin
      Result := FALSE;
      if ( MouseX >= x ) and ( MouseX <= x+SizeX ) and
         ( MouseY >= y ) and ( MouseY <= y+SizeY ) then
      if Result then Invert;
      ButtonHit := Result;
   end;
